# -*- coding: utf-8 -*-
# Filename: preferenceIcontray.py
 
from PyQt4.QtCore import *
from PyQt4.QtGui import *


class preferenceIcontray(QWidget):
	
	def __init__(self, parent = None, *args):
		QWidget.__init__(self, parent)
		
		mainLayout = QVBoxLayout(None)
		mainLayout.setContentsMargins(5, 0, 0, 230)
		self.enableTray = QCheckBox(_('Enable tray icon'), self)
		self.enableTray.setChecked(True)
		self.enableNotify = QCheckBox(_('Enable the notify from tray icon'), self)
		layout1 = QHBoxLayout(None)
		layout1.setContentsMargins(10, 0, 200, 0)
		self.trayTimeLabel = QLabel(_('Tray info lasts (seconds):'))
		self.trayTime = QSpinBox(self)
		self.trayTime.setMaximum(15)
		self.trayTime.setMinimum(1)
		layout1.addWidget(self.trayTimeLabel)
		layout1.addWidget(self.trayTime)
		mainLayout.addWidget(self.enableTray)
		mainLayout.addWidget(self.enableNotify)
		mainLayout.addLayout(layout1)
		self.setLayout(mainLayout)
		
		self.connect(self.enableTray, SIGNAL("toggled(bool)"), self.enableButtons)
		#self.connect(self.enableTray,SIGNAL("toggled(bool)"), self.trayTime, SLOT("setEnabled(bool)"))
		self.connect(self.enableNotify, SIGNAL("toggled(bool)"), self.trayTime, SLOT("setEnabled(bool)"))
	
	def enableButtons(self, b):
		self.enableNotify.setEnabled(b)
		if(not b):
			self.trayTime.setEnabled(False)
		if(b and self.enableNotify.isChecked()):
			self.trayTime.setEnabled(True)