# -*- coding: utf-8 -*-
# Filename: engine_lrc123.py

import engine, urllib, re

class lrc123(engine.engine):
	
	def __init__(self, proxy, locale=None):
		engine.engine.__init__(self, proxy, locale)
		#self.netEncoder = 'gb18030'
	
	def lrc123Parser(self, a):
		b=[]
		for i in a:
			r = re.search('<span class="highlighter">(.*?)</span></a>.*?span class="highlighter">(.*?)</span></a>.*?<a href="/download/lrc/(.*?)">LRC', i, re.S)
			try:
				_artist = r.group(1).replace(r'</span><span class="highlighter">', '')
				_title = r.group(2).replace(r'</span><span class="highlighter">', '')
				_url = 'http://www.lrc123.com/download/lrc/'+r.group(3)
			except:
				pass
			else:
				b.append([_artist, _title, _url])
		return b
	
	def request(self, artist, title):
		url1 = 'http://www.lrc123.com/?keyword='
		url2_pre = '%s %s' %(title, artist)
		url2 = urllib.quote_plus(url2_pre)
		url3 = '&field=lyrics'
		url = url1+url2+url3
		
		try:
			file = urllib.urlopen(url, None, self.proxy)
			tmp = file.read()
			file.close()
		except IOError:
			return (None, True)
		else:
			tmpList = re.findall(r'<div class="newscont mb15" style="line-height:160%;">.*?target="lrc123_player"', tmp, re.S)
			if(len(tmpList) == 0):
				return (None, False)
			else:
				lrcList = self.lrc123Parser(tmpList)
				return (lrcList, False) 
