# -*- coding: utf-8 -*-
# Filename: engine_soso.py

import engine,urllib,re

class soso(engine.engine):
	
	def __init__(self, proxy, locale = None):
		engine.engine.__init__(self, proxy, locale)
		self.netEncoder = 'gb18030'
	
	def changeUrlToGb(self, info):
		address = unicode(info, self.locale).encode('gb18030')
		return address
	
	def sosoParser(self, a):
		b=[]
		for i in a:
			r = re.search('title=\'(.*?)\'.*?title="(.*?)">',i, re.S)
			try:
				_title = r.group(1)
				_artist = re.sub('<font.*?>|</font>', '', r.group(2))
				_url = 'http://cgi.music.soso.com/fcgi-bin/fcg_download_lrc.q?song=%s&singer=%s&down=1' %(urllib.quote_plus(self.changeUrlToGb(_title)), urllib.quote_plus(self.changeUrlToGb(_artist)))
			except:
				pass
			else:
				b.append([_artist, _title, _url])
		return b
	
	def request(self,artist,title):
		url1 = 'http://cgi.music.soso.com/fcgi-bin/m.q?w='
		url3 = '&source=1&t=7'
		url2_pre='%s+%s' %(self.changeUrlToGb(title),self.changeUrlToGb(artist))
		url2 = urllib.quote_plus(url2_pre)
		url = url1+url2+url3
		
		try:
			file=urllib.urlopen(url, None, self.proxy)
			lrc_gb = file.read()
			file.close()
		except IOError:
			return (None, True)
		else:
			tmp = unicode(lrc_gb, 'gb18030').encode('utf8')
			tmpList = re.findall(r'class="title_song">.*?class="song_ablum">', tmp, re.S)
			print len(tmpList)
			if(len(tmpList) == 0):
				return (None, False)
			else:
				lrcList = self.sosoParser(tmpList)
				return (lrcList, False) 
